Option Strict Off
Option Explicit On 

Imports System
Imports System.Threading

' The ThreadWithState class contains the information needed for
' a task, the method that executes the task, and a delegate
' to call when the task is complete.
'
Friend Class BuildPDF
    ' State information used in the task.
    Private TempFile As String
    Private PDFFile As String
    Private JobOptionsFile As String
    Private ApplySecurity As Boolean
    Private ShowWindow As Boolean
    Private SpoolJobs As Boolean

    ' Delegate used to execute the callback method when the
    ' task is complete.
    'Private callback As ExampleCallback

    ' The constructor obtains the state information and the
    ' callback delegate.
    Public Sub New(ByVal strTempFile As String, ByVal strPDFFile As String, ByVal strJobOptionsFile As String, ByVal blnApplySecurity As Boolean, ByVal blnShowWindow As Boolean, ByVal blnSpoolJobs As Boolean) ', ByVal callbackDelegate As ExampleCallback)
        TempFile = strTempFile
        PDFFile = strPDFFile
        JobOptionsFile = strJobOptionsFile
        ApplySecurity = blnApplySecurity
        ShowWindow = blnShowWindow
        SpoolJobs = blnSpoolJobs
        'callback = callbackDelegate
    End Sub

    ' The thread procedure performs the task, such as
    ' formatting and printing a document, and then invokes
    ' the callback delegate with the number of lines printed.
    Public Sub ThreadProc()
        Dim i As Short
        Dim objAdobeDistiller2 As ACRODISTXLib.PdfDistiller6
        Dim objAdobeDistiller As ACRODISTXLib.PdfDistiller
        If ApplySecurity = True Then 'And Val(AcrobatVersion) > 5 Then
            objAdobeDistiller2 = New ACRODISTXLib.PdfDistiller6
            objAdobeDistiller2.bShowWindow = ShowWindow
            objAdobeDistiller2.bSpoolJobs = SpoolJobs
            'RaiseEvent StartCreatingPDF(strPDFFile, True)
            i = objAdobeDistiller2.FileToPDF2(TempFile, PDFFile, JobOptionsFile, True)
            'UPGRADE_NOTE: Object objAdobeDistiller2 may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1029"'
            objAdobeDistiller2 = Nothing
            'RaiseEvent DoneCreatingPDF(strPDFFile, True)
        Else
            objAdobeDistiller = New ACRODISTXLib.PdfDistiller
            'objAdobeDistiller = GetObject(, "ACRODISTXLib.PdfDistiller")
            'objAdobeDistiller = CreateObject("ACRODISTXLib.PdfDistiller")
            objAdobeDistiller.bShowWindow = ShowWindow
            objAdobeDistiller.bSpoolJobs = SpoolJobs
            'RaiseEvent StartCreatingPDF(strPDFFile, False)
            i = objAdobeDistiller.FileToPDF(TempFile, PDFFile, JobOptionsFile)
            'UPGRADE_NOTE: Object objAdobeDistiller may not be destroyed until it is garbage collected. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup1029"'
            objAdobeDistiller = Nothing
            'RaiseEvent DoneCreatingPDF(strPDFFile, False)
        End If
        GC.Collect()
        GC.WaitForPendingFinalizers()
        'If Not callback Is Nothing Then callback(1)
    End Sub
End Class

' Delegate that defines the signature for the callback method.
'
'Public Delegate Sub ExampleCallback(ByVal lineCount As Integer)

' Entry point for the example.
'

